import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class TestHomeworkStudent {
    Student studentFranta = new Student(23, "Franta");
    Student studentKarel = new Student(15, "Karel");
    Student studentPetr = new Student(19, "Petr");
    Homework homeworkProgramming = new Homework(1,"PVA třídy", "PVA");
    Homework homeworkMath = new Homework(2,"Matika příklady", "MAT");
    Homework homeworkHWS = new Homework(3,"HWS sestav síť", "HWS");






    @Test
    void simpleMakeStudent ()
    {
        assertEquals("Karel", studentKarel.getNameOfStudent());
        assertEquals(15,studentKarel.getIdStudent());

    }

    @Test
    void simpleMakeStudent2 ()
    {
        assertEquals("Franta", studentFranta.getNameOfStudent());
        assertEquals(23,studentFranta.getIdStudent());

    }

    @Test
    void getAndSetStudent ()
    {
        simpleMakeStudent2();
        studentFranta.setIdStudent(25);
        assertEquals(25,studentFranta.getIdStudent());

        simpleMakeStudent();
        studentKarel.setIdStudent(10);
        assertEquals(10,studentKarel.getIdStudent());
    }

    @Test
    void getAndSetStudent2 ()
    {
        simpleMakeStudent2();
        studentFranta.setNameOfStudent("Lukáš");
        assertEquals("Lukáš",studentFranta.getNameOfStudent());

        simpleMakeStudent();
        studentKarel.setNameOfStudent("Olda");
        assertEquals("Olda",studentKarel.getNameOfStudent());
    }

    @Test
    void addOneHomework ()
    {
        studentKarel.addHomework(homeworkProgramming);
        assertEquals(homeworkProgramming, studentKarel.getListOfStudentHomeworks().get(0));

    }
    @Test
    void addMoreHomeworks1 ()
    {
        studentPetr.addHomework(homeworkProgramming);
        studentPetr.addHomework(homeworkHWS);
        assertEquals(homeworkProgramming, studentPetr.getListOfStudentHomeworks().get(0));
        assertEquals(homeworkHWS, studentPetr.getListOfStudentHomeworks().get(1));
    }

    @Test
    void addMoreHomeworks2 ()
    {
        studentPetr.addHomework(homeworkHWS);
        studentPetr.addHomework(homeworkMath);
        assertEquals(homeworkHWS, studentPetr.getListOfStudentHomeworks().get(0));
        assertEquals(homeworkMath, studentPetr.getListOfStudentHomeworks().get(1));
    }
    @Test
    void addMoreHomeworks3 ()
    {
        studentPetr.addHomework(homeworkProgramming);
        studentPetr.addHomework(homeworkMath);
        studentPetr.addHomework(homeworkHWS);
        assertEquals(homeworkProgramming, studentPetr.getListOfStudentHomeworks().get(0));
        assertEquals(homeworkMath, studentPetr.getListOfStudentHomeworks().get(1));
        assertEquals(homeworkHWS, studentPetr.getListOfStudentHomeworks().get(2));

    }

    @Test
    void removeHomeworkSimple ()
    {
        addMoreHomeworks1();
        studentPetr.deleteHomeworkById(1);
        assertEquals(homeworkHWS, studentPetr.getListOfStudentHomeworks().get(0));
    }

    @Test
    void removeMoreHomeworks ()
    {
        addMoreHomeworks3();
        studentPetr.addHomework(new Homework(4, "Homework Special", "Speciální"));
        studentPetr.deleteHomeworkById(1);
        studentPetr.deleteHomeworkById(3);
        assertEquals(2, studentPetr.getListOfStudentHomeworks().get(0).getIdHomework());
        assertEquals(4, studentPetr.getListOfStudentHomeworks().get(1).getIdHomework());
    }
}
